# -*- coding: UTF-8 -*-

from artix.common.py2to3utils import configparser
from artix.common.singleton import Singleton
import os


class NesConfig:
    __metaclass__ = Singleton
    path = os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/nes_load.ini')

    def __init__(self):
        self.config = configparser.RawConfigParser()
        self.config.read(NesConfig.path)
        self.isCash = True

    def getInt(self, section, option, defaultValue=0):
        if self.config.has_section(section) and self.config.has_option(section, option):
            return self.config.getint(section, option)
        return defaultValue

    def getBool(self, section, option, defaultValue=False):
        if self.config.has_section(section) and self.config.has_option(section, option):
            return self.config.getboolean(section, option)
        return defaultValue

    def getString(self, section, option, defaultValue=''):
        if self.config.has_section(section) and self.config.has_option(section, option):
            return self.config.get(section, option)
        return defaultValue

    def setMode(self, isCash):
        self.isCash = isCash

    def reread(self):
        self.config.read(NesConfig.path)


config = NesConfig()
