import mysql.simplesql as sql


def insertTmcSupplier(tmcsupplier):
    yield sql.Insert(table='tmcsupplier', values={
        'tmccode': tmcsupplier.get('tmccode', ''),
        'suppliercode': tmcsupplier.get('suppliercode', None),
        'agentpaymentobject': tmcsupplier.get('agentpaymentobject', None)
    })


def deleteTmcSupplier(tmcsupplier):
    tmccode = tmcsupplier.get('tmccode', None)
    suppliercode = tmcsupplier.get('suppliercode', None)
    agentpaymentobject = tmcsupplier.get('agentpaymentobject', None)
    yield sql.Delete(table='tmcsupplier', whereFields=['tmccode', 'suppliercode', 'agentpaymentobject'], 
            whereValues=[tmccode, suppliercode, agentpaymentobject])


def deleteTmcSuppliersBySomeField(tmcsupplier):
    tmccode = tmcsupplier.get('tmccode', None)
    suppliercode = tmcsupplier.get('suppliercode', None)
    if suppliercode is None:
        yield sql.Delete(table='tmcsupplier', whereFields=['tmccode'], whereValues=[tmccode])
    elif tmccode is None:
        yield sql.Delete(table='tmcsupplier', whereFields=['suppliercode'], whereValues=[suppliercode])
    else:
        yield sql.Delete(table='tmcsupplier', whereFields=['tmccode', 'suppliercode'], whereValues=[tmccode, suppliercode])


def clearTmcSupplier():
    yield sql.DeleteAll('tmcsupplier')
